
datablock ShapeBaseImageData(EmptyShieldImage)
{
	className = 	"WeaponImage";
	shapeFile = 	"base/data/shapes/empty.dts";
	mountpoint =	"0";

	lightType = "ConstantLight";
	lightColor = "0 0 1 1";
	lightRadius = 5;

	offset = "0 2 .05";

	stateName[0]                   = "Activate";
	stateTimeoutValue[0]           = 0.15;
	stateTransitionOnTimeout[0]    = "Ready";

	stateName[1]			= "Ready";
	stateEmitter[1]			= "HPBlueShieldEmitter";
	stateEmitterTime[1]		= 300;
	stateAllowImageChange[1]	= "true";
	stateTransitiononTimeout[1]	= "Activate";
};

datablock ShapeBaseImageData(EmptyCaptureShieldImage)
{
	className = 	"WeaponImage";
	shapeFile = 	"base/data/shapes/empty.dts";
	mountpoint =	"0";
	offset = 	"0 2 .05";

	lightType = "ConstantLight";
	lightColor = "1 0.5 0";
	lightRadius = 5;

	stateName[0]                   = "Activate";
	stateTimeoutValue[0]           = 0.15;
	stateTransitionOnTimeout[0]    = "Ready";

	stateName[1]			= "Ready";
	stateEmitter[1]			= "HPCaptureShieldEmitter";
	stateEmitterTime[1]		= 1;
	stateTimeoutValue[1]		= 1;
	stateTransitionOnTimeout[1]	= "Ready";
	stateAllowImageChange[1]	= "true";
	stateTransitiononAmmo[1] 	= "Armed";

	stateName[2]			= "Armed";
	stateEmitter[2]			= "HPArmedShieldEmitter";
	stateEmitterTime[2]		= 3;
	stateTimeoutValue[2]		= 2;
	stateTransitionOnTimeout[2]	= "Armed";
	stateAllowImageChange[2]	= "true";
	stateTransitionOnNoAmmo[2]	= "Ready";
};

function EmptyCaptureShieldImage::OnMount(%this, %obj, %slot)
{
	%obj.setImageAmmo(%slot, 0);
}

function Player::createShield(%player)
{
	%player.shielded = 1;
	%player.mountImage(EmptyShieldImage, 3);
	%player.spellActive = 1;
	
}
function Player::createCaptureShield(%player)
{
	%player.captureShield = 1;
	%player.shielded = 1;
	%player.spellActive = 1;
	%player.mountimage(EmptyCaptureShieldImage, 3);
}

function Player::killShield(%player)
{
	if(%player.captureShield && %player.heldProjs >= 1)
	{
		%player.returnToSender();
	}
	%player.captureShield = 0;
	%player.shielded = 0;
	%player.spellActive = 0;
	%player.unMountImage(3);
}

package ShieldSpellPackage
{
   function ProjectileData::damage(%this,%obj,%col,%fade,%pos,%normal) 
   {
      if(%col.getType() & $TypeMasks::PlayerObjectType)
      { 
         %scale = getWord(%col.getScale(),2);
         
         %fvec = %col.getForwardVector();
         %fX = getWord(%fvec,0);
         %fY = getWord(%fvec,1);
         
         %evec = %col.getEyeVector();
         %eX = getWord(%evec,0);
         %eY = getWord(%evec,1);
         %eZ = getWord(%evec,2);
         
         %eXY = mSqrt(%eX*%eX+%eY*%eY);
         
         %aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
         
         if(%col.shielded)
         {
            if(%eZ > 0.75)
               %shielded = (getword(%pos, 2) > getword(%col.getWorldBoxCenter(),2) - 3.3*%scale);
            else if(%ez < -0.75)
               %shielded = (getword(%pos, 2) < getword(%col.getWorldBoxCenter(),2) - 4.4*%scale);
            else
               %shielded = (vectorDot(vectorNormalize(%obj.getVelocity()),%aimVec) < 0);
            
            %damageScale = 0;
            if(%shielded)
               %col.spawnExplosion(hammerProjectile,getWord(%col.getScale(),2));
         }
      }
      
      if(%shielded)
      {
         //cancel radius damage on %obj
         %obj.damageCancel[%col] = 1;
         %obj.impulseScale[%col] = %impulseScale;
         serverPlay3d(wrenchMissSound,%pos);

         if(%col.CaptureShield)
         {
		if(%this.getName() !$= "HPEmptyProjectile" && %this.getName() !$= "HPGrabProjectile" && %this.getName() !$= "HPPlayerGrabProjectile" && %this.getName() !$= "HPControlProjectile" && %this.getName() !$= "HPPainProjectile" && %this.getName() !$= "HPKillProjectile")
		{
			%col.heldProjs++;
			%col.heldProj[%col.heldProjs] = %this;
			%col.setImageAmmo(3, 1);
		}
         }
         
         %obj.schedule(10,delete);
	 return 0;
         
         //Special effect weapons like the Horse Ray will still affect you from the back
         if(%damageScale > 0)
         {
            %this.directDamage *= %damageScale;
            %ret = Parent::damage(%this,%obj,%col,%fade,%pos,%normal);
            %this.directDamage /= %damageScale;
         }
         
         return %ret;
      }
      else
      {
         return Parent::damage(%this,%obj,%col,%fade,%pos,%normal);
      }
   }

   function ProjectileData::radiusDamage(%this, %obj, %col, %distanceFactor, %pos, %damageAmt)
   {
      if(%obj.damageCancel[%col])
         return;
      
      return Parent::radiusDamage(%this, %obj, %col, %distanceFactor, %pos, %damageAmt);
   }
   
   function ProjectileData::radiusImpulse(%this, %obj, %col, %a, %pos, %b, %c)
   {
      if(%obj.damageCancel[%col])
      {
         %b = %b * %obj.impulseScale[%col];
      }
      
      return Parent::radiusImpulse(%this, %obj, %col, %a, %pos, %b, %c);
   }
};
activatePackage(ShieldSpellPackage);

function Player::ReturnToSender(%player)
{
	if(%player.heldProjs >= 1)
	{
		%projs = %player.heldProjs;
		%spread = 0.001 * %player.heldProjs;
		for(%i = 1; %i <= %projs; %i++)
		{
			%proj = %player.heldProj[%i];
			%vec = %player.getMuzzleVector(0);
			%plVel = %player.getVelocity();
			%vec1 = VectorScale(%vec, %proj.muzzleVelocity);
			%vec2 = VectorScale(%plVel, %proj.velInheritFactor);
			%vel = VectorAdd(%vec1,%vec2);
			%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
			%vel = MatrixMulVector(%mat, %vel);

			%p = new Projectile()
			{
				dataBlock = %proj.getName();
				initialPosition = vectorAdd(%player.getmuzzlePoint(0), %vec);
				initialVelocity = %vel;
				sourceObject = %player;
				client = %player.client;
			};
			MissionCleanup.add(%p);
			%p.setScale(%player.scale);
			%player.heldProjs--;
			%player.proj[%i] = "";
		}
		serverplay3d("PrintFireSound",%player.getMuzzlePoint(0));
		%player.unMountImage(3);
	}
}