datablock ProjectileData(HPGrabProjectile)
{
   directDamage        = 0;
   directDamageType    = $DamageType::PortalCrush;
   radiusDamageType    = $DamageType::PortalCrush;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 100;
   verticalImpulse	  = 50;
 //explosion           = gunExplosion;
   particleEmitter     = "HPWhiteTrailEmitter";

   muzzleVelocity      = 150;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 30000;
   fadeDelay           = 700;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.10;
   isBallistic         = true;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   //for the spells system
   spellFireSound = "printFireSound";
};
$Spells::MaxGrabDist = HPGrabProjectile.muzzleVelocity * (HPGrabProjectile.lifetime / 33); //for some reason each second of lifetime is "33", unsure why
datablock ProjectileData(HPPlayerGrabProjectile : HPGrabProjectile)
{
	particleEmitter = "HPYellowTrailEmitter";
};
datablock ProjectileData(HPKillProjectile)
{
	directDamage 		= 9999999999999; //just die ok
	directDamageType 	= $Damagetype::Generic;
	radiusDamageType 	= $Damagetype::Generic;

	brickExplosionRadius 	= 0;
	brickExplosionImpact 	= false;          //destroy a brick if we hit it directly?
	brickExplosionForce  	= 0;
	brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
	brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

	impactImpulse	    	= 100;
	verticalImpulse	  	= 50;
	//explosion           	= gunExplosion;
	particleEmitter     	= "HPLimeTrailEmitter";

	muzzleVelocity      	= 150;
	velInheritFactor    	= 0;

	armingDelay         	= 0;
	lifetime            	= 30000;
	fadeDelay           	= 700;
	bounceElasticity    	= 0.5;
	bounceFriction      	= 0.10;
	isBallistic         	= true;
	gravityMod 		= 0.0;

	hasLight    		= false;
	lightRadius 		= 3.0;
	lightColor  		= "0 0 0.5";

   	//for the spells system
	spellFireSound 		= "printFireSound";
};
datablock ProjectileData(HPControlProjectile)
{
	directDamage 		= 0.001; 
	directDamageType 	= $Damagetype::Generic;
	radiusDamageType 	= $Damagetype::Generic;

	brickExplosionRadius 	= 0;
	brickExplosionImpact 	= false;          //destroy a brick if we hit it directly?
	brickExplosionForce  	= 0;
	brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
	brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

	impactImpulse	    	= 100;
	verticalImpulse	  	= 50;
	//explosion           	= gunExplosion;
	particleEmitter     	= "HPYellowTrailEmitter";

	muzzleVelocity      	= 150;
	velInheritFactor    	= 0;

	armingDelay         	= 0;
	lifetime            	= 30000;
	fadeDelay           	= 700;
	bounceElasticity    	= 0.5;
	bounceFriction      	= 0.10;
	isBallistic         	= true;
	gravityMod 		= 0.0;

	hasLight    		= false;
	lightRadius 		= 3.0;
	lightColor  		= "0 0 0.5";

   	//for the spells system
	spellFireSound 		= "printFireSound";
};
datablock ProjectileData(HPPoopProjectile)
{
   directDamage        = 10;
   directDamageType    = $DamageType::PortalCrush;
   radiusDamageType    = $DamageType::PortalCrush;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground
	
	ProjectileShapeName = "./Resources/poop.dts";

   impactImpulse	     = 100;
   verticalImpulse	  = 50;
 //explosion           = gunExplosion;
   particleEmitter     = "HPBrownCloudEmitter";

   muzzleVelocity      = 50;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 30000;
   fadeDelay           = 700;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.10;
   isBallistic         = true;
   gravityMod = 3.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   //for the spells system
   spellFireSound = "printFireSound"; //"poopSound";
};
datablock ProjectileData(HPShrinkProjectile)
{
	directDamage 		= 0.001; 
	directDamageType 	= $Damagetype::Generic;
	radiusDamageType 	= $Damagetype::Generic;

	brickExplosionRadius 	= 0;
	brickExplosionImpact 	= false;          //destroy a brick if we hit it directly?
	brickExplosionForce  	= 0;
	brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
	brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

	impactImpulse	    	= 100;
	verticalImpulse	  	= 50;
	//explosion           	= gunExplosion;
	particleEmitter     	= "HPPurpleTrailEmitter";

	muzzleVelocity      	= 150;
	velInheritFactor    	= 0;

	armingDelay         	= 0;
	lifetime            	= 30000;
	fadeDelay           	= 700;
	bounceElasticity    	= 0.5;
	bounceFriction      	= 0.10;
	isBallistic         	= true;
	gravityMod 		= 0.0;

	hasLight    		= false;
	lightRadius 		= 3.0;
	lightColor  		= "0 0 0.5";

   	//for the spells system
	spellFireSound 		= "printFireSound";
};
datablock ProjectileData(HPGrowProjectile)
{
	directDamage 		= 0.001; 
	directDamageType 	= $Damagetype::Generic;
	radiusDamageType 	= $Damagetype::Generic;

	brickExplosionRadius 	= 0;
	brickExplosionImpact 	= false;          //destroy a brick if we hit it directly?
	brickExplosionForce  	= 0;
	brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
	brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

	impactImpulse	    	= 100;
	verticalImpulse	  	= 50;
	//explosion           	= gunExplosion;
	particleEmitter     	= "HPCyanTrailEmitter";

	muzzleVelocity      	= 150;
	velInheritFactor    	= 0;

	armingDelay         	= 0;
	lifetime            	= 30000;
	fadeDelay           	= 700;
	bounceElasticity    	= 0.5;
	bounceFriction      	= 0.10;
	isBallistic         	= true;
	gravityMod 		= 0.0;

	hasLight    		= false;
	lightRadius 		= 3.0;
	lightColor  		= "0 0 0.5";

   	//for the spells system
	spellFireSound 		= "printFireSound";
};