function Player::SpawnProjectileFromMuzzle(%obj, %proj)
{	
	%vector = %obj.getMuzzleVector(0);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %proj.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %proj.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);

	%p = new Projectile()
	{
		dataBlock = %proj;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(0);
		sourceObject = %obj;
		sourceSlot = 0;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	if(%proj.spellFireSound !$= "")
	{
		serverplay3d(%proj.spellFireSound,%obj.getTransform());
	}
	return %p;
}

function Player::CastSpell(%obj, %spellType)
{
	if(%spellType.altCMD != 0)
	{
		spellAltCMD(%obj, %spelltype.altCMD);
		return;
	}
		//%spellProj = %spellType.datablock;
		%obj.spawnProJectileFromMuzzle(%spellType); ///make this func later
}

function serverCmdSpell1(%client, %spellA, %spellB)
{
	if(%spellB !$= "")
	{
		%spellname = %spellA SPC %spellB;
	}
	else
	{
		%spellname = %spellA;
	}
	if(%client.manualcast)
	{
		messageClient(%client, '', "\c2Cancelled casting \c0" @ %client.spell1 @ "\c2 due to changing spells.");
		%client.manualCast = 0;
	}
	setSpell1(%client, %spellname);
}
function serverCmdSpell2(%client, %spellA, %spellB)
{
	if(%spellB !$= "")
	{
		%spellname = %spellA SPC %spellB;
	}
	else
	{
		%spellname = %spellA;
	}
	if(%client.manualcast)
	{
		messageClient(%client, '', "\c2Cancelled casting \c0" @ %client.spell1 @ "\c2 due to changing spells.");
		%client.manualCast = 0;
	}
	setSpell2(%client, %spellname);
}

function SetSpell1(%client, %spellname)
{
	for(%i = 0; %i < $Spells::NumSpells; %i++)
	{
		if(%spellname $= "")
		{
			break;
		}
		if($Spells::SpellName[%i] $= %spellname)
		{
			%client.spell1 = $Spells::SpellName[%i];
			%client.spell1proj = $Spells::SpellProj[%i];
			%client.spell1altcmd = $Spells::SpellaltCMD[%i];
			if(!%client.manualCast)
			{
				messageClient(%client, '', "\c2Primary spell set as \c0" @ $Spells::SpellName[%i] @ "\c2!");
			}
			else
			{
				messageClient(%client, '', "\c2Prepared to cast \c0" @ $Spells::SpellName[%i] @ "\c2. Press left mouse to cast, or right mouse to cancel.");
			}
			return true;	
		}
	}
	messageClient(%client, '', "\c2Spell not found! Try again, fool.");
	return false;
}
function SetSpell2(%client, %spellname)
{
	for(%i = 0; %i < $Spells::NumSpells; %i++)
	{
		if(%spellname $= "")
		{
			break;
		}
		if($Spells::SpellName[%i] $= %spellname)
		{
			%client.spell2 = $Spells::SpellName[%i];
			%client.spell2proj = $Spells::Spellproj[%i];
			%client.spell2altcmd = $Spells::SpellAltCMD[%i];
			messageClient(%client, '', "\c2Secondary spell set as \c0" @ $Spells::SpellName[%i] @ "\c2!");
			return true;
		}
	}
	messageClient(%client, '', "\c2Spell not found! Try again, fool.");
	return false;
}

function servercmdCastSpell(%client, %spellA, %spellB)
{
	if(!%client.manualcast)
	{
		%client.manualCast = 1;

		%client.spell1stored = %client.spell1;
		%client.spell1projstored = %client.spell1proj;
		%client.spell1altcmdstored = %client.spell1altcmd;
	}
	else
	{
		messageClient(%client, '', "\c2Cancelled casting \c0" @ %client.spell1 @ "\c2 due to changing spells.");
	}
	if(%spellB !$= "")
	{
		%spellname = %spellA SPC %spellB;
	}
	else
	{
		%spellname = %spellA;
	}
	setSpell1(%client, %spellname);
}

//spell title, projectile datablock name, alternate command function
//Examples:
//Incendio, HPFireProjectile, 0
//Lumos, 0, WandLight()
//Format: Spell | Projectile SPC AltCmd # (next spell)

function buildSpellList()
{
	%f = new FileObject();
	%f.openForRead("Add-ons/Item_HpWand/Spells/spellList.txt");
	$Spells::NumSpells = 100; 	//%f.getNumLines()-1;
	$Spells::SpellList = "";
	$Spells::SpellCount = 5;
	for(%i = 0; %i < $Spells::NumSpells; %i++)
	{
		%line = %f.readLine();
		if(getSubStr(%line, 0, 2) $= "//")
		{
			continue;
		}
		if(%line $= "")
		{
			break;
		}
		$Spells::SpellIndex[%i] = %line;
		%hashPos = strPos(%line, "#");
		%altCMDPos = StrPos(%line, "|");
		
		if($Spells::SpellIndex[%i] !$= "")
		{
			$Spells::SpellName[%i] = getSubStr(%line, 0, %hashPos-1);
			$Spells::SpellProj[%i] = firstword(getSubStr(%line, %hashPos+2, %altCMDPos-1));
			if($Spells::SpellProj[%i] $= "0" || $Spells::SpellProj[%i] $= ""){$Spells::SpellProj[%i] = "HpEmptyProjectile";}
			$Spells::SpellAltCMD[%i] = getSubStr(%line, %altCMDPos+2, strLen(%line) - %altCMDPos + 2);
			if(!isObject($Spells::SpellProj[%i])){$Spells::SpellName[%i] = ""; continue;}
			if($Spells::SpellList $= "") //if(%i == 1)
			{
				$Spells::SpellList  = $Spells::SpellName[%i];
				$Spells::SpellCount++;
			}
			else
			{
				$Spells::SpellList = $Spells::SpellList @" | "@ $Spells::SpellName[%i];
				$Spells::SpellCount++;
			}
		}
	}
	echo("Spell List Built: " @ $Spells::SpellList);
}
buildSpellList();

function serverCmdSpellList(%client)
{
	messageClient(%client, '', "\c2Spell List: ");
	for(%i = 0; %i < $Spells::SpellCount; %i++)
	{
		if($Spells::SpellName[%i] $= "")
		{
			continue;
		}
		messageClient(%client, '', "\c6" @ $Spells::SpellName[%i]);
		commandToClient(%client, 'updateSpellList', $Spells::Spellname[%i], %i-1);
	}
	messageClient(%client, '', "\c3You may need to scroll up to see the full list.");
}

function serverCmdUpdateMySpells(%client)
{
	%client.hasHogClient = 1;
	for(%i = 0; %i < $Spells::SpellCount; %i++)
	{
		if($Spells::SpellName[%i] $= "")
		{
			continue;
		}
		commandToClient(%client, 'updateSpellList', $Spells::Spellname[%i], %i-1);
	}
	commandToClient(%client, 'HogClient_HandshakeComplete');
}

function Player::spellAltCMD(%player, %altCMD, %val) //for special, nonprojectile spells
{
	switch$(%altCMD)
	{
		case "LightWand": 
			if(!%player.wandlit && %val){%player.LightWand();}else if(!%val){%player.NoxWand();}	
		case "createCaptureShield": 
			if(!%player.shielded && %val){%player.createCaptureShield();}else if(!%val){%player.killShield();}
		case "createShield": 
			if(!%player.shielded && %val){%player.createShield();}else if(!%val){%player.killShield();}
		default: 
			echo("Spell Error: Alt Command does not exist!");
	}
}


